import Either from '@hexadrop/either';
import DomainError from '@hexadrop/error';
import QueryBus from './bus.js';
import Query from './query.js';
import QueryHandlers from './query-handlers.js';
import '@hexadrop/types/class';
import '@hexadrop/types/nullable';
import '@hexadrop/types/primitives';

declare class SyncQueryBus implements QueryBus {
    private readonly info;
    constructor(info: QueryHandlers);
    ask<ResponseType>(query: Query<ResponseType>): Either<DomainError, ResponseType> | Promise<Either<DomainError, ResponseType>>;
}

export { SyncQueryBus as default };
